VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cStrRev"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' by Wpsjr1@syix.com - Paul
' Original idea by damian

' not as fast as Native StrReverse, but close :P


Private Type TPROC
    hMem As Long
    vtPtr As Long
End Type
Private aProc() As TPROC

Private Declare Function SysReAllocStringLen Lib "oleaut32" (ByVal pbstr As Long, ByVal psz As Long, ByVal cch As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)

Private Declare Sub DebugBreak Lib "kernel32" ()


Dim lLen As Long, lpFunction As Long

Private Sub RevStr(ByVal sIn As String, ByVal sOut As String)
  InlineASM "558BEC8B750C8B5EFC8B7D10D1EB8D7FFC8BCB83E101740F32D98D7F04668B045E6689078D7FFED1E38D76FCB9040000008B043303F9C1C0102BD9890777F2C9C20C00" 'rol
End Sub

Friend Function StrReverseX(ByVal sIn As String) As String
  lLen = Len(sIn)
  
  If lLen > 1 Then
    lpFunction = VarPtr(StrReverseX)
    SysReAllocStringLen lpFunction, 0, lLen
    RevStr sIn, StrReverseX
  Else
    StrReverseX = sIn ' vbNullString or single character
  End If
End Function

Private Sub InlineASM(ByRef sASM As String)
    Dim i As Long, aSize As Long, aB() As Byte
    
    aSize = Len(sASM) \ 2
    Debug.Assert aSize Xor 1
    ReDim Preserve aB(1 To aSize)
    For i = 1 To aSize
        aB(i) = Val("&H" & Mid$(sASM, i * 2 - 1, 2))
    Next
    
    Static cp As Long
    ReDim Preserve aProc(cp)
    Dim hMem As Long, lPtr As Long
    hMem = GlobalAlloc(0, aSize)
    lPtr = GlobalLock(hMem)
    ' I'm tempted to call GlobalSize here and fill the end of the buffer with &h90 (nop) if its larger than requested
    RtlMoveMemory ByVal lPtr, aB(1), aSize
    GlobalUnlock hMem
    
    aProc(cp).hMem = hMem
    aProc(cp).vtPtr = VTable(cp)
    VTable(cp) = lPtr
    cp = cp + 1
End Sub

Private Sub Class_Initialize()
    Dim a(0) As String, s As String
    RevStr "", ""
End Sub

Private Sub Class_Terminate()
    On Error GoTo E
    Dim i As Long
    For i = 0 To UBound(aProc)
        VTable(i) = aProc(i).vtPtr
        GlobalFree aProc(i).hMem
    Next
E:
End Sub

Private Property Get VTable(ByVal Index As Long) As Long
    Dim p As Long
    
    Index = &H1C + Index * 4
    RtlMoveMemory p, ByVal ObjPtr(Me), 4
    RtlMoveMemory VTable, ByVal p + Index, 4
End Property

Private Property Let VTable(ByVal Index As Long, ByVal ProcPtr As Long)
    Dim p As Long
    Dim x As Long
    Dim lOldProtect As Long
    
    Index = &H1C + Index * 4
    RtlMoveMemory p, ByVal ObjPtr(Me), 4
    RtlMoveMemory ByVal p + Index, ProcPtr, 4
End Property

